// @TODO change "handlings" to "maintenance"

<script setup>
import CardHandlingCreate from '@/components/card_handlings/CardHandlingCreate.vue'
import CardHandlingBrowse from '@/components/card_handlings/CardHandlingBrowse.vue'
</script>

<template>
<div>
  <div>
    <CardHandlingCreate :header_id=header_id
                        :handling_id=handling_id
                        :airship_type_id=airship_type_id
                        :user_type=user_type
                        :on_browse='() => {state = "browse"}'
                        v-if='state=="add_new" && $store.state.user?.is_staff'/>

    <CardHandlingCreate :header_id=header_id
                        :handling_id=handling_id
                        :airship_type_id=airship_type_id
                        :user_type=user_type
                        :initial_object=record
                        :after_post_callback='() => {state = "browse"}'
                        :on_browse='() => {state = "browse"}'
                        v-else-if='state=="edit" && $store.state.user?.is_staff' />

    <CardHandlingBrowse :header_id=header_id
                        :user_type=user_type
                        :on_edit='OnChildButtonEdit'
                        :on_add_new='() => {state = "add_new"}'
                        v-else-if='state=="browse"' />
  </div>

  </div>
</template>

<script>
import { setAuthorizationToken } from "../utils/authUtils";
import { getCardHandlingById } from "../utils/apiUtils";
import { getUserType } from "../store/index";

export default {
  name: "CardHandling",
  props: {
    header_id : {
      type: String,
      required: true
    },
    handling_id : {
      type: String,
      required: true
    },
    airship_type_id : {
      type: String,
      required: true
    }
  },
  data: function() {
    return {
      record: null,
      state: "browse",
      user_type: getUserType()
    };
  },
  methods: {
    afterPostCallback() {
      this.state = "browse";
    },
    OnChildButtonEdit(id) {
      if (id) {
        (async () => {
            setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
            this.record = await getCardHandlingById(id)
            this.state = "edit"
        })();
      }
    }
  },
  mounted: function() {}
};
</script>

<style scoped>

</style>>